---
title: POST /structured-content/content-types
slug: content-marketing-platform/api/post-structured-contentcontent-types
docTags: 
createdAt: 2026-10-01T18:51:26.265Z
---

{
  "id": "AamCEz_Vhkhsz34BY7tJK",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.cmp.optimizely.com/v3/structured-content/content-types",
    "servers": [
      {
        "url": "https://api.cmp.optimizely.com/v3/structured-content/content-types",
        "description": "v3 version of Optimizely CMP Open API"
      }
    ],
    "name": "POST /structured-content/content-types",
    "description": "<p>Experimental Create content type.</p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "",
          "customType": "SCContentTypeCreateRequest",
          "schema": [
            {
              "name": "details",
              "kind": "required",
              "type": "object",
              "description": "",
              "modelRef": "#/components/schemas/CoreContentType",
              "customType": "CoreContentType",
              "schema": [
                {
                  "name": "name",
                  "kind": "required",
                  "type": "string",
                  "description": "Name of the content type"
                },
                {
                  "name": "description",
                  "kind": "optional",
                  "type": "string",
                  "description": "Description of the content type"
                },
                {
                  "name": "component",
                  "kind": "required",
                  "type": "boolean",
                  "description": "Indicates whether the content type is a component"
                },
                {
                  "name": "disabled",
                  "kind": "optional",
                  "type": "boolean",
                  "description": "Disabled status of the content type"
                },
                {
                  "name": "thumbnail_guid",
                  "kind": "optional",
                  "type": "string",
                  "description": "Thumbnail GUID of the content type"
                }
              ]
            },
            {
              "name": "source",
              "kind": "optional",
              "type": "string",
              "description": "Source for the content type"
            },
            {
              "name": "field_definitions",
              "kind": "required",
              "type": "array",
              "description": "",
              "modelRef": "#/components/schemas/NumberFieldDefinition",
              "customType": "NumberFieldDefinition[]",
              "schema": [
                {
                  "name": "core",
                  "kind": "required",
                  "type": "object",
                  "description": "",
                  "modelRef": "#/components/schemas/CoreFieldDef",
                  "customType": "CoreFieldDef",
                  "schema": [
                    {
                      "name": "key",
                      "kind": "required",
                      "type": "string",
                      "description": "Key of the field"
                    },
                    {
                      "name": "name",
                      "kind": "required",
                      "type": "string",
                      "description": "Name of the field"
                    },
                    {
                      "name": "is_list",
                      "kind": "required",
                      "type": "boolean",
                      "description": "Indicates whether the field is a list"
                    },
                    {
                      "name": "is_required",
                      "kind": "required",
                      "type": "boolean",
                      "description": "Required status of the field"
                    },
                    {
                      "name": "need_internationalization",
                      "kind": "required",
                      "type": "boolean",
                      "description": "Indicates whether the field needs internationalization"
                    },
                    {
                      "name": "min_list_length",
                      "kind": "optional",
                      "type": "integer",
                      "description": "Minimum length of the list"
                    },
                    {
                      "name": "max_list_length",
                      "kind": "optional",
                      "type": "integer",
                      "description": "Maximum length of the list"
                    },
                    {
                      "name": "field_type",
                      "kind": "optional",
                      "type": "string",
                      "description": "An enumeration.",
                      "modelRef": "#/components/schemas/FieldType",
                      "customType": "FieldType",
                      "schema": []
                    },
                    {
                      "name": "source_id",
                      "kind": "optional",
                      "type": "string",
                      "description": "Source ID of the field"
                    },
                    {
                      "name": "source_metadata",
                      "kind": "optional",
                      "type": "string",
                      "description": "Source metadata of the field"
                    },
                    {
                      "name": "order_index",
                      "kind": "optional",
                      "type": "integer",
                      "description": "Order index of the field"
                    },
                    {
                      "name": "help_text",
                      "kind": "optional",
                      "type": "string",
                      "description": "Helptext of the field"
                    },
                    {
                      "name": "editor_metadata",
                      "kind": "optional",
                      "type": "object",
                      "description": "Editor metadata of the field",
                      "complexType": "anyOf",
                      "complexItems": [],
                      "schema": []
                    }
                  ]
                },
                {
                  "name": "min_value",
                  "kind": "optional",
                  "type": "number",
                  "description": "Minimum value of the field"
                },
                {
                  "name": "max_value",
                  "kind": "optional",
                  "type": "number",
                  "description": "Maximum value of the field"
                },
                {
                  "name": "default_values",
                  "kind": "optional",
                  "type": "array",
                  "description": "Default values of the field",
                  "example": "",
                  "itemType": "number",
                  "customType": "number[]",
                  "itemExample": "",
                  "itemDefault": ""
                }
              ]
            },
            {
              "name": "created_by",
              "kind": "required",
              "type": "string",
              "description": "Unique identifier of the user who is creating the content type"
            },
            {
              "name": "expected_locales",
              "kind": "optional",
              "type": "array",
              "description": "Expected locales for the content type",
              "example": "",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            },
            {
              "name": "source_id",
              "kind": "optional",
              "type": "string",
              "description": "Source ID for the content type"
            },
            {
              "name": "source_metadata",
              "kind": "optional",
              "type": "string",
              "description": "Source metadata for the content type"
            }
          ],
          "modelRef": "#/components/schemas/SCContentTypeCreateRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "OAuth2",
          "name": "OAuth2",
          "kind": "optional",
          "type": "oauth2",
          "oauth2Flows": {
            "clientCredentials": {
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {}
            },
            "authorizationCode": {
              "authorizationUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/auth",
              "tokenUrl": "https://accounts.cmp.optimizely.com/o/oauth2/v1/token",
              "scopes": {
                "openid": "Grants the ability to receive a unique identifier for the user.",
                "profile": "Grants access to user profile information.",
                "offline_access": "Grants the ability to refresh access_token using the refresh token even when user is not present (not logged in)."
              }
            }
          },
          "requiredScopes": [
            "openid",
            "profile",
            "offline_access"
          ]
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "200",
        "description": "Successful response",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "SCContentTypeCreateResponse",
            "schema": [
              {
                "name": "created",
                "kind": "required",
                "type": "boolean",
                "description": "Created status of the requested content type"
              },
              {
                "name": "content_type_guid",
                "kind": "optional",
                "type": "string",
                "description": "Unique identifier of the content type"
              },
              {
                "name": "content_type_version_guid",
                "kind": "optional",
                "type": "string",
                "description": "Unique identifier of the content type version"
              }
            ],
            "modelRef": "#/components/schemas/SCContentTypeCreateResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "201",
        "description": "Created",
        "jsonExample": "",
        "isExpanded": true,
        "headers": [
          {
            "kind": "optional",
            "name": "Location",
            "type": "string",
            "description": "URL to get the created resource"
          }
        ],
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "SCContentTypeCreateResponse",
            "schema": [
              {
                "name": "created",
                "kind": "required",
                "type": "boolean",
                "description": "Created status of the requested content type"
              },
              {
                "name": "content_type_guid",
                "kind": "optional",
                "type": "string",
                "description": "Unique identifier of the content type"
              },
              {
                "name": "content_type_version_guid",
                "kind": "optional",
                "type": "string",
                "description": "Unique identifier of the content type version"
              }
            ],
            "modelRef": "#/components/schemas/SCContentTypeCreateResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "422",
        "description": "Validation error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "",
            "customType": "HTTPValidationError",
            "schema": [
              {
                "name": "detail",
                "kind": "optional",
                "type": "array",
                "description": "Details of the error",
                "modelRef": "#/components/schemas/ValidationError",
                "customType": "ValidationError[]",
                "schema": [
                  {
                    "name": "loc",
                    "kind": "required",
                    "type": "array",
                    "description": "Locations where the error occurred",
                    "example": "",
                    "itemType": "string",
                    "customType": "string[]",
                    "itemExample": "",
                    "itemDefault": ""
                  },
                  {
                    "name": "msg",
                    "kind": "required",
                    "type": "string",
                    "description": "Message describing the error"
                  },
                  {
                    "name": "type",
                    "kind": "required",
                    "type": "string",
                    "description": "Type of the error"
                  }
                ]
              }
            ],
            "modelRef": "#/components/schemas/HTTPValidationError",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "glyduQyLwYKcB6IyJ8NNO",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.cmp.optimizely.com/v3/structured-content/content-types \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"details\": {\n     \"name\": \"\",\n     \"component\": \"\"\n     },\n     \"field_definitions\": [\n     {\n     \"core\": {\n     \"key\": \"\",\n     \"name\": \"\",\n     \"is_list\": \"\",\n     \"is_required\": \"\",\n     \"need_internationalization\": \"\"\n     }\n     }\n     ],\n     \"created_by\": \"\"\n     }'"
        },
        {
          "id": "ZZIp8j7FYljSbPk4U3pYh",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"details\": {\n      \"name\": \"\",\n      \"component\": \"\"\n   },\n   \"field_definitions\": [\n      {\n         \"core\": {\n            \"key\": \"\",\n            \"name\": \"\",\n            \"is_list\": \"\",\n            \"is_required\": \"\",\n            \"need_internationalization\": \"\"\n         }\n      }\n   ],\n   \"created_by\": \"\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.cmp.optimizely.com/v3/structured-content/content-types\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "PNRUJiu1gbJYYqyNujJ9i",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.cmp.optimizely.com/v3/structured-content/content-types\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"details\": {\n      \"name\": \"\",\n      \"component\": \"\"\n   },\n   \"field_definitions\": [\n      {\n         \"core\": {\n            \"key\": \"\",\n            \"name\": \"\",\n            \"is_list\": \"\",\n            \"is_required\": \"\",\n            \"need_internationalization\": \"\"\n         }\n      }\n   ],\n   \"created_by\": \"\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "ZqNKnHfMRm__G904T0pii",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.cmp.optimizely.com/v3/structured-content/content-types\"\n\npayload = json.dumps({\n   \"details\": {\n      \"name\": \"\",\n      \"component\": \"\"\n   },\n   \"field_definitions\": [\n      {\n         \"core\": {\n            \"key\": \"\",\n            \"name\": \"\",\n            \"is_list\": \"\",\n            \"is_required\": \"\",\n            \"need_internationalization\": \"\"\n         }\n      }\n   ],\n   \"created_by\": \"\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "glyduQyLwYKcB6IyJ8NNO"
    },
    "results": {
      "languages": [
        {
          "id": "response-0-200",
          "language": "200",
          "code": "// Successful response\n{\n  \"created\": false,\n  \"content_type_guid\": \"\",\n  \"content_type_version_guid\": \"\"\n}"
        },
        {
          "id": "response-1-201",
          "language": "201",
          "code": "// Created\n{\n  \"created\": false,\n  \"content_type_guid\": \"\",\n  \"content_type_version_guid\": \"\"\n}"
        },
        {
          "id": "response-2-422",
          "language": "422",
          "code": "// Validation error\n{\n  \"detail\": [\n    {\n      \"loc\": [\n        \"\"\n      ],\n      \"msg\": \"\",\n      \"type\": \"\"\n    }\n  ]\n}"
        }
      ],
      "selectedLanguageId": "response-0-200"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}